{===============================================================================
Basic Module management
--------------------------------------------------------------------------------
 2001 Infersys,  D. Oldfield
===============================================================================}
unit MainF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Contnrs;

type
  TfrmMain = class(TForm)
    btnModules: TButton;
    btnShowForm: TButton;
    lstModules: TListBox;
    btnClose: TButton;
    dlgModules: TOpenDialog;
    procedure btnCloseClick(Sender: TObject);
    procedure btnModulesClick(Sender: TObject);
    procedure btnShowFormClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FHandles : TList;
    procedure LoadModule(aFile: string);
    procedure UnLoadModules;
  public

  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  FHandles := TList.Create;

  dlgModules.InitialDir := ExtractFilePath(Application.ExeName);
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	UnLoadModules;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  FHandles.Free;
end;

{------------------------------------------------------------------------------}
{ Button events }

procedure TfrmMain.btnModulesClick(Sender: TObject);
begin
	if dlgModules.Execute then
  begin
  	lstModules.Items.Add(ExtractFileName(dlgModules.FileName));
		LoadModule(dlgModules.FileName);
  end;
end;

procedure TfrmMain.btnShowFormClick(Sender: TObject);
{ We need carnal knowledge of the package for this, modular?? }
var
  aClass: TPersistentClass;
  aForm : TForm;
begin
  aClass := GetClass('TfrmPlugIn');	//Must be registered to succeed

  if Assigned(aClass)then
  begin
    aForm := TFormClass(AClass).Create(Application);
    aForm.Show;
  end;
end;

procedure TfrmMain.btnCloseClick(Sender: TObject);
begin
	Close;
end;

{------------------------------------------------------------------------------}
{ Module methods }

procedure TfrmMain.LoadModule(aFile: string);
var
  Module: THandle;
begin
  Module := LoadPackage(aFile); 	//LoadPackage returns a handle..

	FHandles.Add(Pointer(Module));  //..which is stored here
end;

procedure TfrmMain.UnLoadModules;

	procedure FreeForms;
  var
  	Loop: Integer;
  begin
		for Loop := Screen.FormCount - 1 downto 0 do
  	begin
  		if Screen.Forms[Loop].ClassName = 'TfrmPlugIn' then  //knowledge again
    		Screen.Forms[Loop].Free;
  	end;
  end;

var
	Loop : Integer;
  aModule: THandle;
  
begin
  FreeForms; //MUST make sure all created forms destroyed first

	for Loop := 0 to FHandles.Count - 1 do
  begin
  	aModule := THandle(FHandles[Loop]);

  	UnRegisterModuleClasses(aModule);
    UnLoadPackage(aModule);
  end;
end;

END.
