{===============================================================================
Same as demo 1 but nice name for the package
--------------------------------------------------------------------------------
 2001 Infersys,  D. Oldfield
===============================================================================}
unit MainF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmMain = class(TForm)
    btnModules: TButton;
    btnShowForm: TButton;
    lstModules: TListBox;
    btnClose: TButton;
    dlgModules: TOpenDialog;
    procedure btnCloseClick(Sender: TObject);
    procedure btnModulesClick(Sender: TObject);
    procedure btnShowFormClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FHandles : TList;
    procedure LoadModule(aFile: string);
    procedure UnloadModules;
  public

  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  FHandles  := TList.Create;

  dlgModules.InitialDir := ExtractFilePath(Application.ExeName);
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	UnloadModules;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  FHandles.Free;
end;

{------------------------------------------------------------------------------}
{ Button events }

procedure TfrmMain.btnModulesClick(Sender: TObject);
begin
	if dlgModules.Execute then
  begin
		LoadModule(dlgModules.FileName);
  end;
end;

procedure TfrmMain.btnShowFormClick(Sender: TObject);
var
  aClass: TPersistentClass;
  aForm : TForm;
begin
  aClass := GetClass('TfrmPlugIn');	//Must be registered to succeed

  if Assigned(aClass)then
  begin
    aForm := TFormClass(AClass).Create(Application);
    aForm.Show;
  end;
end;

procedure TfrmMain.btnCloseClick(Sender: TObject);
begin
	Close;
end;

{------------------------------------------------------------------------------}
{ Module methods }

procedure TfrmMain.LoadModule(aFile: string);
var
  Module: THandle;
  Descrip: string;
begin
  Module := LoadPackage(aFile); 	//LoadPackage returns a handle
	FHandles.Add(Pointer(Module));  //store reference to module

{ Get 'nice' name this time }
  Descrip:= GetPackageDescription(PChar(aFile));
  lstModules.Items.Add(Descrip);
end;

procedure TfrmMain.UnloadModules;

  procedure FreeModuleComponents(aModule: THandle);
  var
		Loop : Integer;
    M: TMemoryBasicInformation;
  begin
  	with Application do
    begin
      for Loop := ComponentCount - 1 downto 0 do
      begin
        VirtualQuery(Components[Loop].ClassType, M, SizeOf(M));
        if (aModule = 0) or (HMODULE(M.AllocationBase) = aModule) then
          Components[Loop].Free;
      end;
    end;
	end;

var
	Loop : Integer;
  aModule: THandle;

begin
	for Loop := FHandles.Count - 1 downto 0 do
  begin
  	aModule := THandle(FHandles[Loop]);

		FreeModuleComponents(aModule); 		//destroy all created forms

  	UnRegisterModuleClasses(aModule);
    UnLoadPackage(aModule);
  end;
end;

END.
